// wrapper.js
// ------------------------------------------------------------------
//
// created: Thu Nov 29 09:49:07 2018
// last saved: <2018-November-29 10:09:03>

/* jshint esversion: 6, node: true */
/* global process, console, Buffer */

'use strict';


function edgeFunction(fn) {
  // wrap a nodeback fn with a Promise
  return function() {
    const self = this; // want this refers to "org"
    console.log('typeof self = ' + typeof self);
    const args = [].slice.call(arguments);

    // pop the existing callback, if any
    const maybeCallback = typeof args[args.length - 1] == 'function' && args.pop();

    return new Promise ( (resolve, reject) => {
      // push a new callback, and within *that*, invoke the orig cb
      [].push.call(args, function wrapperCallback(e, result) {
        if (maybeCallback) {
          maybeCallback(e, result);
        }
        if (e) { reject(e); }
        else { resolve(result); }
      } );
      fn.apply(self, args);
    });
  };
}
